import numpy as np


class ImprovementQuery:
    def __init__(self, threshold, period):
        self.threshold = threshold
        self.period = period

    def query(self, reward_array):
        if reward_array.shape < self.period:
            return False

        else:
            first = reward_array[-self.period]
            last = reward_array[-1]

            slope = (last - first) / self.period

            return slope < self.threshold
